# ================================================================================== #
# === PSYCHOSTATS 3.1 - Ranks & Statistics & RealtimeCalc system for Psychostats === #
# === include autobalance based on KDR									         === #
# === Modification for Counter-Strike:Source Servers                             === #
# === Author: Ch@meleon (snake_nas@mail.ru)										 === #
# === Version: 0.6.1															 === #
# === -------------------------------------------------------------------------- === #
# ================================================================================== #
import os, socket, struct, re, sys, cfglib, es, repeat, langlib, playerlib, MySQLdb, popuplib, keyvalues, usermsg, services
info = es.AddonInfo()
info.name = 'Psychostats Ranks, Statistics & Autobalance'
info.version = '0.6.1'
info.basename = 'psstats'
info.url = 'http://forums.mattie.info/cs/forums/viewtopic.php?t=30247'
info.author = 'Ch@meleon'

# ================================================================================== #
# ==========  G l o b a l   C o n f i g u r a t i o n  V a r i a b l e s  ========== #
# ================================================================================== #
# Modify the variables below to your needs...

# ===== Psycho Stats ===== #
ps_atb					= 2 				# AutoTeamBalance Mode: 0 - off, 1 -only show team-balance, 2 - by rounds, 3 - by minutes
ps_atb_attempts			= 3					# How often rounds/minutes ATB can rebalance teams (default 5)
ps_atb_minplayers		= 4					# Minimum players on server to ATB swap players (default 4)
ps_atb_diff				= 0.4				# Points difference to ATB swap players (default 0.4)
ps_atb_anounce			= 2					# Anouncement level when swap players (0 - disabled, 1 - show swap players, 2 - show all anouncements)
ps_atb_mover			= 1					# Enables swap players (when disabled only shown who needed to swap)
ps_skilldiff_anounce	= 1					# Enables anounce when player skill changes by kills or game events (as bomb defused etc) are happened
ps_rewrite_points		= 0					# Overwrite points settings from psychostats web statistic
ps_admin_anounce		= 1					# Anounce when Mani-admin join to server (tracking by uniqueId from PsychoStats)
ps_webstats_recalc		= 1					# Enables recalculate webstats each time when map ends (default 0)
ps_force_team			= 0					# Force player team when reconect or changed team and join
ps_cmd_anounce			= 1					# Anounce available ps-stats chat commands

# = Chat cmd definition == #
ps_cmd_top				= 'top'			# Top (top10) cmd
ps_cmd_session			= 'session'		# Session cmd
ps_cmd_statsme			= 'statsme'		# Statsme cmd
ps_cmd_kpd				= 'kpd'			# KPD cmd
ps_cmd_rank				= 'rank'		# Rank cmd
ps_cmd_hitbox			= 'hitbox'		# Hitbox cmd
#ps_cmd_weaponstat		= 'weaponstat'	# Weaponstat cmd (featured)

# ==== MySQL Settings ==== #
ps_mysql_hostname		= 'localhost'	# Server / Hostname for the mysql server (webserver), localhost if webserver is on same machine as cstrike server.
ps_mysql_username		= 'root'		# Username, needed to login on the sql server
ps_mysql_password		= ''			# Password, also needed to login on the sql server
ps_mysql_database		= 'psychostats3_1'		# Database - Where you want the data to be stored.
ps_mysql_tbl_prefix		= 'ps_'			# Table prefix (default 'ps_')

# ==== WebPS Recalculate Options ==== #
ps_os_stats_path		= 'C:/Perl/stats/PS/stats.pl'

# ==== Admin Settings ==== #
# List of unique admin identifications. You must use the same identification that used psychostats
# For example, if your psychostats configured tracking by steamid:
# admin_list = ['STEAM_0:1:12345678','STEAM_0:1:87654321']
# Also, if you configure psychostats by name and use non-international symbols in name,
# you must save this file in codepage UTF-8. Type with no blank characters!
# Mani admins automatically added in this list at start plugin
admin_list = []

# ==== Stats Settings ==== #
ps_stats_multiplier		= 1				# Multiply gained points from a frag (Default:1)
ps_stats_maxpoints		= 10			# Set a max points (security reason) (Default:10)
ps_stats_headshotbonus	= 0.5			# Bonus points for headshots

# Event Bonuses
ps_event_bonus = {   'planted_the_bomb': {'enactor':2, 'enactor_team': 1, 'victim': 0, 'victim_team': -1, 'message': 'Planted the Bomb'} \
    				,'defused_the_bomb':  {'enactor':2, 'enactor_team': 0, 'victim': -1, 'victim_team': 0, 'message': 'Defused the Bomb'} \
    				,'rescued_a_hostage':  {'enactor':3, 'enactor_team': 0, 'victim': 0, 'victim_team': 0, 'message': 'Rescued a Hostage'} \
    				,'bomb_runner':  {'enactor':1, 'enactor_team': 0, 'victim': 0, 'victim_team': 0, 'message': 'Bomb has been runned'} \
    				,'bomb_defused':  {'enactor':0, 'enactor_team': 2, 'victim': 0, 'victim_team': -2, 'message': 'Bomb has been defused'} \
    				,'target_bombed':  {'enactor':5, 'enactor_team': 2, 'victim': 0, 'victim_team': -2, 'message': 'Target succesfully bombed'} \
    				,'suicide':  {'enactor':-1, 'enactor_team': 0, 'victim': 0, 'victim_team': 0, 'message': 'Suicide'} \
    				,'all_hostages_rescued':  {'enactor':0, 'enactor_team': 2, 'victim': 0, 'victim_team': -2, 'message': 'All hostages have been rescued'} \
    				,'target_saved':  {'enactor':0, 'enactor_team': 5, 'victim': 0, 'victim_team': -5, 'message': 'Target has been saved'} \
    				,'hostages_not_rescued':  {'enactor':0, 'enactor_team': 2, 'victim': 0, 'victim_team': -2, 'message': 'Hostages have not been rescued'} \
    				,'round_win':  {'enactor':0, 'enactor_team': 0, 'victim': 0, 'victim_team': 0, 'message': '#team round win'} \
    				,'killed_a_hostage':  {'enactor':-3, 'enactor_team': 0, 'victim': 0, 'victim_team': 0, 'message': 'Hostage has been killed'} \
    				,'escaped_as_vip':  {'enactor':10, 'enactor_team': 0, 'victim': 0, 'victim_team': 0, 'message': 'Escaped as VIP'} \
    				,'vip_escaped':  {'enactor':0, 'enactor_team': 5, 'victim': 0, 'victim_team': -5, 'message': 'The VIP has escaped'} \
    				,'assassinated_the_vip':  {'enactor':10, 'enactor_team': 0, 'victim': -5, 'victim_team': 0, 'message': 'Assassinated the VIP'} \
    				,'vip_assassinated':  {'enactor':0, 'enactor_team': 10, 'victim': 0, 'victim_team': -10, 'message': 'The VIP has been assassinated'} \
    				,'vip_not_escaped':  {'enactor':0, 'enactor_team': 5, 'victim': 0, 'victim_team': -5, 'message': 'VIP has not escaped'} \
    				,'ffkill':  {'enactor':-1, 'enactor_team': 0, 'victim': 0, 'victim_team': 0, 'message': 'TeamKill'} \
    				}

# Weapon Bonuses ( Base Points * WeaponBonus )
ps_weapon_bonus = { 'glock': 2, 'usp': 2, 'p228': 2, 'deagle': 2, 'fiveseven': 2, 'elite': 2, 'm3': 1, 'xm1014': 1 \
					, 'tmp': 1, 'mac10': 1, 'mp5navy': 1, 'ump45': 1, 'p90': 1, 'famas': 1, 'galil': 1, 'ak47': 1, 'scout': 2 \
					, 'm4a1': 1, 'sg550': 1, 'g3sg1': 1, 'awp': 0.5, 'sg552': 1, 'aug': 1, 'm249': 1, 'hegrenade': 4 \
					, 'flashbang': 10, 'smokegrenade': 10, 'knife': 4, 'prop_physics': 4, 'world': 0, 'smokegrenade_projectile': 10 }


################################################
# Do not edit below this line !!!!!!!!!!!!!!!!!!
################################################

ps_kv                   = keyvalues.KeyValues(name='ps_settings')
ps_text = None
ps_stats_calc_mode		= 1				# 1 - By steam, 2 - By name, 3 - By ip   (Updated from PS3.1 on init)
ps_stats_include_bots	= 0				# Include bots with statistics?
ps_stats_minplayers     = 2				# Minimum players on server to calc stats
ps_stats_maxdays		= 30			# Max days calculating stats
ps_stats_max_pl_sess	= 15			# Max player sessions
ps_stats_base_skill		= 50			# Base skill for new player

mani_team_join_force_auto = 0
mani_team_join_keep_same_team = 0

pfx = ps_mysql_tbl_prefix
plrsets = {}
plrdata = {}
atb_rounds = 0
team_kdr_t = 0
team_kdr_ct = 0
team_t_plrs = 0
team_ct_plrs = 0
bomb_planter_id = 0
rtc_calc_enabled = 0

sql_c = ''
langs = langlib.Strings(es.getAddonPath("psstats") + "/lang.ini")
#auth = services.use('auth')

# ================================================================================== #
# ===============  M a i n   M o d u l e   A d d o n   S o u r c e  ================ #
# ================================================================================== #
def load():

	es.set(info.basename,info.version)
	es.makepublic(info.basename)
	cst.init()
	cst.getAdminList()
	#ps_kv.load(es.getAddonPath('psstats')+'/config.txt')
	if not es.exists('clientcommand','!psadmin'):
		es.regclientcmd("!psadmin", "psstats/showadmincmd", "PS-Admin menu")
	mani_team_join_force_auto = int(es.ServerVar("mani_team_join_force_auto"))
	mani_team_join_keep_same_team = int(es.ServerVar("mani_team_join_keep_same_team"))
	if ps_force_team==1:
		es.server.queuecmd('mani_team_join_force_auto %s'%'1')
		es.server.queuecmd('mani_team_join_keep_same_team %s'%'1')
	#auth.registerCapability('!psadmin',auth.ADMIN)
	cmdAnounceRep = repeat.create('cmdAnounceRep',cmdAnounce)
	ATBtimer = repeat.create('ATBtimer',atb,('timer'))
	cmdAnounceRep.start(300,0)
	if ps_atb==3:
		ATBtimer = repeat.start(ps_atb_attempts*60,0)
def unload():
	repeat.delete('cmdAnounceRep')
	repeat.delete('ATBtimer')
	if es.exists('clientcommand','!psadmin'):
		es.unregclientcmd("!psadmin")
	cst.close()


def player_say(e):
	global ps_cmd_top, ps_cmd_session, ps_cmd_statsme, ps_cmd_kpd, ps_cmd_rank
	global admin_list
	global ps_text

	chatcmd 	= e['text']
	userid 		= e['userid']
	plr			= playerlib.getPlayer(int(userid))
	uid			= cst.getUniqueId(userid)
	name 		= es.getplayername(userid)


	# === TOP === #
	if(chatcmd == ps_cmd_top):
		showtop10(userid)

	# === RANK === #
	if(chatcmd == ps_cmd_rank):
		uid		= cst.getUniqueId(userid)
		data	= stats.getPlayerData(uid)
		plr = playerlib.getPlayer(userid)
		try:
			cst.langmsg('rank',{'plr':str(name),'place':str(data[1]),'total':str(data[5]),'skill':str(plrsets[uid,'skill'])})
		except:
			es.tell(userid,langs("notyet",{},plr.get("lang")))

	# === SESSION / KPD / STATSME === #
	if(chatcmd == ps_cmd_session):
		showkpd(userid)
	if(chatcmd == ps_cmd_statsme):
		showstatsme(userid)
	if(chatcmd == ps_cmd_kpd):
		showkpd(userid)

	# === HITBOX === #
	if(chatcmd == ps_cmd_hitbox):
		showhitbox(userid)

	# === !PSADMIN === #
	if(chatcmd =='!psadmin'):
		if uid in admin_list:
			showadmin(userid)
		else:
			es.tell(userid,langs("onlyadmin",{},plr.get("lang")))

	# === LANG === #
	if(chatcmd == 'lang'):
			es.tell(userid,'Your language is :' + str(plr.get("lang")))

	#if(chatcmd == 'adm'):
	#	if auth.isUseridAuthorized(userid, "!psadmin"):
	#		es.tell(userid,'You are admin of ES')
	#	else:
	#		es.tell(userid,'You are not admin of ES')


def menuhandler(userid, choice, popupname):
	global plrsets
	global ps_atb, ps_atb_minplayers, ps_atb_diff, ps_atb_attempts
	global ps_atb_anounce, ps_atb_mover, ps_admin_anounce, ps_skilldiff_anounce
	global ps_webstats_recalc, ps_force_team, ps_cmd_anounce
	uid	= cst.getUniqueId(userid)
	#top10
	if popupname == 'top10_popup':
		if choice == 8:
			if plrsets[uid,'top10_prev'] == 1:
				showtop10(userid,plrsets[uid,'top10_from']-20)
		if choice == 9:
			if plrsets[uid,'top10_next'] == 1:
				showtop10(userid,plrsets[uid,'top10_from'])
	#psadmin
	if popupname == 'psadmin':
		if choice == 1:
			ATBtimer = repeat.find('ATBtimer')
			if ps_atb ==0:
				ps_atb=1
			elif ps_atb==1:
				ps_atb=2
				ps_atb_attempts=1
			elif ps_atb==2:
				ps_atb_attempts=ps_atb_attempts + 1
				if ps_atb_attempts>10:
					ps_atb_attempts=1
					ps_atb = 3
					ATBtimer.start(60,0)
			elif ps_atb==3:
				ps_atb_attempts=ps_atb_attempts + 1
				ATBtimer.stop()
				if ps_atb_attempts>10:
					ps_atb_attempts=1
					ps_atb = 0
				if ps_atb==3:
					ATBtimer.start(60*ps_atb_attempts,0)
			showadmin(userid)
		if choice == 2:
			ps_atb_minplayers = ps_atb_minplayers + 1
			if ps_atb_minplayers>10:
				ps_atb_minplayers = 2
			showadmin(userid)
		if choice == 3:
			ps_atb_anounce = ps_atb_anounce + 1
			if ps_atb_anounce>2:
				ps_atb_anounce = 0
			showadmin(userid)
		if choice == 4:
			ps_skilldiff_anounce = 1 - ps_skilldiff_anounce
			showadmin(userid)
		if choice == 5:
			ps_admin_anounce = 1 - ps_admin_anounce
			showadmin(userid)
		if choice == 6:
			ps_cmd_anounce = 1 - ps_cmd_anounce
			showadmin(userid)
		if choice == 7:
			ps_force_team = 1 - ps_force_team
			if ps_force_team==1:
				es.server.queuecmd('mani_team_join_force_auto %s'%'1')
				es.server.queuecmd('mani_team_join_keep_same_team %s'%'1')
			else:
				es.server.queuecmd('mani_team_join_force_auto %s'%str(mani_team_join_force_auto))
				es.server.queuecmd('mani_team_join_keep_same_team %s'%str(mani_team_join_keep_same_team))
			showadmin(userid)

		#es.server.queuecmd('est_spawn %s 1'%userid)
		if choice == 8:
			ps_webstats_recalc = 1 - ps_webstats_recalc
			showadmin(userid)

def showadmincmd():
	showadmin(es.getcmduserid())

#!psadmin
def showadmin(userid):
	global ps_atb, ps_atb_minplayers, ps_atb_diff, ps_atb_attempts
	global ps_atb_anounce, ps_atb_mover, ps_admin_anounce, ps_skilldiff_anounce
	global ps_webstats_recalc
	plr = playerlib.getPlayer(userid)
	psadmin = popuplib.create('psadmin')
	psadmin.addline(langs("psadmin",{},plr.get("lang")))
	psadmin.addline('-----')
	if ps_atb==0:
		mess=langs("off",{},plr.get("lang"))
	elif ps_atb==1:
		mess=langs("onlyshatb",{},plr.get("lang"))
	elif ps_atb==2:
		mess=langs("eachrounds",{'att':str(ps_atb_attempts)},plr.get("lang"))
	elif ps_atb==3:
		mess=langs("eachmins",{'att':str(ps_atb_attempts)},plr.get("lang"))
	#str(ps_atb_attempts)
	psadmin.addline('->1 - ' + langs("atb",{},plr.get("lang")) + ': ' + mess)
	psadmin.addline('->2 - ' + langs("mintoatb",{},plr.get("lang")) + ': ' + str(ps_atb_minplayers))
	psadmin.addline('->3 - ' + langs("atbanlevel",{},plr.get("lang")) + ': ' + str(ps_atb_anounce))
	if ps_skilldiff_anounce==1:
		mess=langs("on",{},plr.get("lang"))
	else:
		mess=langs("off",{},plr.get("lang"))
	psadmin.addline('->4 - ' + langs("anounceskillchanges",{},plr.get("lang")) + ': ' + mess)
	if ps_admin_anounce==1:
		mess=langs("on",{},plr.get("lang"))
	else:
		mess=langs("off",{},plr.get("lang"))
	psadmin.addline('->5 - ' + langs("anounceadmins",{},plr.get("lang")) + ': ' + mess)
	if ps_cmd_anounce==1:
		mess=langs("on",{},plr.get("lang"))
	else:
		mess=langs("off",{},plr.get("lang"))
	psadmin.addline('->6 - ' + langs("anouncecmd",{},plr.get("lang")) + ': ' + mess)
	if ps_force_team==1:
		mess=langs("on",{},plr.get("lang"))
	else:
		mess=langs("off",{},plr.get("lang"))
	psadmin.addline('->7 - ' + langs("forceteam",{},plr.get("lang")) + ': ' + mess)
	if ps_webstats_recalc==1:
		mess=langs("on",{},plr.get("lang"))
	else:
		mess=langs("off",{},plr.get("lang"))
	psadmin.addline('->8 - ' + langs("recalcpermap",{},plr.get("lang")) + ': ' + mess)
	psadmin.addline('-----')
	psadmin.addline('->0 - '+langs("exit",{},plr.get("lang")))
	psadmin.menuselect = menuhandler
	psadmin.send(userid)

#top10
def showtop10(userid,startfrom = 0):
	global sql_c
	global plrsets
	global pfx
	cst.checkDBconn()
	q = sql_c.cursor()
	uid	= cst.getUniqueId(userid)
	plrsets[uid,'top10_from'] = startfrom + 10
	top10popup = popuplib.create('top10_popup')
	top10popup.addline('->1 - Top Players')
	top10popup.addline('-----')
	#q.execute('SELECT 0 n, MAX( pln.name ) name, plr.skill, (plr.skill - plr.prevskill )skilldiff, SUM( pld.kills ) , SUM( pld.deaths )  FROM `'+pfx+'plr` plr, `'+pfx+'plr_ids_name` pln, `'+pfx+'plr_data` pld WHERE pln.plrid = plr.plrid AND pld.plrid = plr.plrid AND pln.totaluses = ( SELECT max( totaluses ) FROM `'+pfx+'plr_ids_name` n WHERE n.plrid = pld.plrid ) GROUP BY pln.name, plr.skill, plr.prevskill ORDER BY plr.rank  LIMIT ' + str(startfrom) +',11')
	q.execute("SELECT r.rank, (SELECT ifnull(MAX(name),r.uniqueid) FROM `"+pfx+"plr_profile` n WHERE n.uniqueid = r.uniqueid) name, r.skill pts,(SELECT coalesce(ROUND(SUM(kills)/SUM(deaths),2),1) kdr FROM `"+pfx+"plr_data` d WHERE d.plrid = r.plrid) kdr FROM `"+pfx+"plr` r WHERE r.rank between "+str(startfrom+1)+" and "+str(startfrom+11)+" ORDER BY r.rank")

	numrows = int(q.rowcount)
	nextp = 0
	for x in range(0, numrows):
		t = x + 1 + startfrom
		if(t < 10):
			posr = '0' + str(t)
		else:
			posr = str(t)

		c = q.fetchone()
		name = c[1]
		pts = c[2]
		kdr = c[3]
		#ptsdif = c[2]
		#if (ptsdif > 0):
		#	ptsdif = '+' + str(ptsdif)
		#if (c[4] == 0):
		#	kdr = "%.2f" % round(float(c[3])/float(1),2)
		#else:
		#	kdr = "%.2f" % round(float(c[3])/float(c[4]),2)
		if x<10:
			top10popup.addline(str(posr)+' '+str(name) +' ('+str(pts)+') , KDR: '+str(kdr))
		else:
			nextp = 1

	top10popup.addline('-----')
	plrsets[uid,'top10_prev'] = 0
	plrsets[uid,'top10_next'] = 0
	if startfrom>0:
		top10popup.addline('->8 - Prev')
		plrsets[uid,'top10_prev'] = 1
	if nextp>0:
		top10popup.addline('->9 - Next')
		plrsets[uid,'top10_next'] = 1
	top10popup.addline('->0 - Exit')
	top10popup.menuselect = menuhandler
	top10popup.send(userid)
	q.close()

#statsme
def showstatsme(userid):
	global rankPopup
	uid				= cst.getUniqueId(userid)
	data 			= stats.getPlayerData(uid)
	plr = playerlib.getPlayer(userid)
	try:
		rank			= data[1]
	except:
		es.tell(userid,'You are yet not in statistic. You must kill more players!')
		return 1
	rank_old		= data[2]
	#skill 			= data[3]
	#skill_old		= data[4]
	skill			= plrsets[uid,'skill']
	skill_old		= data[3]

	plrcnt			= data[5]
	plr_kills		= data[6]
	plr_deaths		= data[7]
	plr_hskills		= data[8]
 	plr_ffkills		= data[9]
	plr_ffdeaths	= data[10]
	plr_kills_str	= data[11]
	plr_deaths_str	= data[12]
	plr_suicides	= data[13]
	plr_games		= data[14]
	plr_rounds		= data[15]
	plr_online		= data[16]
	plr_ctkills		= data[17]
	plr_tkills		= data[18]
	plr_ctdeaths	= data[19]
	pld_tdeaths		= data[20]
	pld_bomb_def_att= data[21]
	pld_bomb_def_def= data[22]
	pld_bomb_exp	= data[23]
	pld_bomb_pl		= data[24]
	pld_bomd_sp		= data[25]
	pld_killhost	= data[26]
	pld_reschost	= data[27]
	pld_touchhost	= data[28]
	pld_ctwon		= data[29]
	pld_ctlost		= data[30]
	pld_twon		= data[31]
	pld_tlost		= data[32]
	plr_s_points	= data[33]
	plr_s_kills		= data[34]
	plr_s_deaths	= data[35]
	plr_s_hk		= data[36]
	plr_s_ffkills	= data[37]
	prl_s_ffdeaths	= data[38]
	plr_s_suicides	= data[39]

	rankchange = rank_old - rank
	if(rankchange > 0):
		rc = '+' + str(rankchange)
	elif(rankchange < 0):
		rc = str(rankchange)
	else:
		rc = ''

	skillchange = skill - skill_old
	if(skillchange > 0):
		skc = '+' + str(skillchange)
	elif(skillchange < 0):
		skc = str(skillchange)
	else:
		skc = ''

	if (plr_deaths == 0):
		kdr = "%.2f" % round(float(plr_kills)/float(1),2)
	else:
		kdr = "%.2f" % round(float(plr_kills)/float(plr_deaths),2)

	t_rounds = pld_twon + pld_tlost
	ct_rounds = pld_ctwon + pld_ctlost
	if (t_rounds > ct_rounds):
		pref_team = 'T'
	else:
		pref_team = 'CT'

	try:
		kpm = "%.2f" % round( float(plr_kills) / float(plr_online) * 60 ,2)
	except:
		kpm = "0.00"

	rankPopup = popuplib.create('rank_popup')
	rankPopup.addline('->1 - ' + langs("rundown",{},plr.get("lang")))
	rankPopup.addline('      ' + langs("position",{},plr.get("lang")) + ' ' + str(rank) + ' ('+rc+')' + ' '+langs("of",{},plr.get("lang"))+' '+str(plrcnt))
	rankPopup.addline('      ' + langs("skillpts",{'skill':str(skill)},plr.get("lang")))
	rankPopup.addline('      ' + langs("totalgames",{},plr.get("lang")) + ': ' + str(plr_games))
	rankPopup.addline('      ' + langs("totalrounds",{},plr.get("lang")) + ': ' + str(plr_rounds))
	rankPopup.addline('  ')
	rankPopup.addline('->2 - ' + langs("killprofile",{},plr.get("lang")))
	rankPopup.addline('      KDR: ' +kdr)
	rankPopup.addline('      ' + langs("kpm",{},plr.get("lang")) + ': ' + str(kpm))
	rankPopup.addline('      ' + langs("killstreak",{},plr.get("lang")) + ': ' + str(plr_kills_str))
	rankPopup.addline('      ' + langs("deathstreak",{},plr.get("lang")) + ': ' + str(plr_deaths_str))
	rankPopup.addline('  ')
	rankPopup.addline('->3 - ' + langs("teamprofile",{},plr.get("lang")))
	rankPopup.addline('      ' + langs("prefteam",{},plr.get("lang")) + ': ' + pref_team)
	rankPopup.addline('      ' + str(pld_twon) + ' ' + langs("twins",{},plr.get("lang")))
	rankPopup.addline('      ' + str(pld_tlost) + ' ' + langs("tloses",{},plr.get("lang")))
	rankPopup.addline('      ' + str(pld_ctwon) + ' ' + langs("ctwins",{},plr.get("lang")))
	rankPopup.addline('      ' + str(pld_ctlost) + ' ' + langs("ctloses",{},plr.get("lang")))
	rankPopup.addline('  ')
	rankPopup.addline('->4 - ' + langs("actionprofile",{},plr.get("lang")))
	rankPopup.addline('    ' + str(pld_bomb_pl) + ' ' + langs("bombsplanted",{},plr.get("lang")))
	rankPopup.addline('    ' + str(pld_bomb_def_def) + ' ' + langs("bombsdefused",{},plr.get("lang")))
	rankPopup.addline('    ' + str(pld_reschost) + ' ' + langs("hostresc",{},plr.get("lang")))
	rankPopup.addline('  ')

	rankPopup.send(userid)


#session, kpd
def showkpd(userid):
	global rankPopup, plrsets
	uid				= cst.getUniqueId(userid)
	data 			= stats.getPlayerData(uid)
	plr = playerlib.getPlayer(userid)
	rank			= data[1]
	rank_old		= data[2]
	skill 			= data[3]
	skill_old		= data[4]
	plrcnt			= data[5]
	plr_kills		= data[6] + plrsets[uid,'s_kills']	#in test
	plr_deaths		= data[7] + plrsets[uid,'s_deaths']	#in test
	plr_hskills		= data[8] + plrsets[uid,'s_headshots'] #in test
 	plr_ffkills		= data[9]
	plr_ffdeaths	= data[10]
	plr_kills_str	= data[11]
	plr_deaths_str	= data[12]
	plr_suicides	= data[13]
	plr_games		= data[14]
	plr_rounds		= data[15]
	plr_online		= data[16]
	plr_ctkills		= data[17]
	plr_tkills		= data[18]
	plr_ctdeaths	= data[19]
	pld_tdeaths		= data[20]
	pld_bomb_def_att= data[21]
	pld_bomb_def_def= data[22]
	pld_bomb_exp	= data[23]
	pld_bomb_pl		= data[24]
	pld_bomd_sp		= data[25]
	pld_killhost	= data[26]
	pld_reschost	= data[27]
	pld_touchhost	= data[28]
	pld_ctwon		= data[29]
	pld_ctlost		= data[30]
	pld_twon		= data[31]
	pld_tlost		= data[32]
	plr_s_points	= data[33]
	plr_s_kills		= data[34]
	plr_s_deaths	= data[35]
	plr_s_hk		= data[36]
	plr_s_ffkills	= data[37]
	prl_s_ffdeaths	= data[38]
	plr_s_suicides	= data[39]

	try:
		hp = float (100 / float(plr_kills))
		hpc = int( float(hp) * float(plr_hskills))
	except:
		hpc = '0'

	rankchange = rank_old - rank
	if(rankchange > 0):
		rc = '+' + str(rankchange)
	elif(rankchange < 0):
		rc = str(rankchange)
	else:
		rc = '+0'

	if (plr_deaths == 0):
		kdr = "%.2f" % round(float(plr_kills)/float(1),2)
	else:
		kdr = "%.2f" % round(float(plr_kills)/float(plr_deaths),2)

	if (plr_s_points > 0):
		plr_s_points = '+' + str(plr_s_points)

	skillchange = plrsets[uid,'skill'] - skill
	if(skillchange > 0):
		skc = '+' + str(skillchange)
	elif(skillchange < 0):
		skc = str(skillchange)
	else:
		skc = ''


	rankPopup = popuplib.create('rank_popup')
	rankPopup.addline('->1 - ' + langs("totalranking",{},plr.get("lang")))
	rankPopup.addline('      ' + langs("position",{},plr.get("lang")) + ' ' + str(rank) + ' ' + langs("of",{},plr.get("lang")) + ' '+str(plrcnt))
	#rankPopup.addline('      ' + str(skill) + ' Points')
	rankPopup.addline('      ' + str(plrsets[uid,'skill']) + ' ' + langs("points",{},plr.get("lang")))
	rankPopup.addline('      ' + str(plr_kills) + ' : ' + str(plr_deaths) + ' ' + langs("frags",{},plr.get("lang")))
	rankPopup.addline('      ' + str(plr_hskills) + ' (' + str(hpc) + '%) ' + langs("headshots",{},plr.get("lang")))
	rankPopup.addline('      ' + kdr + ':' + ' KDR')
	rankPopup.addline('  ')
	rankPopup.addline('->2 - ' + langs("thissession",{},plr.get("lang")))
	#rankPopup.addline('      ' + str(plr_s_points) + ' Points')
	#rankPopup.addline('      ' + str(plr_s_kills) + ' : ' + str(plr_s_deaths) + ' Frags')
	#rankPopup.addline('      ' + str(rc) + ' Positions')
	#rankPopup.addline('      ' + str(plr_s_hk) + ' Headshots')
	rankPopup.addline('      ' + str(skc) + ' ' + langs("points",{},plr.get("lang")))
	rankPopup.addline('      ' + str(plrsets[uid,'s_kills']) + ' : ' + str(plrsets[uid,'s_deaths']) + ' ' + langs("frags",{},plr.get("lang")))
	rankPopup.addline('      ' + str(rc) + ' ' + langs("position",{},plr.get("lang")))
	rankPopup.addline('      ' + str(plrsets[uid,'s_headshots']) + ' ' + langs("headshots",{},plr.get("lang")))
	rankPopup.addline('  ')
	rankPopup.addline('->3 - ' + langs("achievements",{},plr.get("lang")))
	rankPopup.addline('    ' + str(plr_ffkills) + ' ' + langs("teamkills",{},plr.get("lang")))
	rankPopup.addline('    ' + str(plr_suicides) + ' ' + langs("suicides",{},plr.get("lang")))
	rankPopup.addline('    ' + str(pld_bomb_pl) + ' ' + langs("bombsplanted",{},plr.get("lang")))
	rankPopup.addline('    ' + str(pld_bomb_def_def) + ' ' + langs("bombsdefused",{},plr.get("lang")))
	rankPopup.addline('    ' + str(pld_reschost) + ' ' + langs("hostresc",{},plr.get("lang")))
	rankPopup.addline('    ' + str(pld_killhost) + ' ' + langs("hostkill",{},plr.get("lang")))
	rankPopup.addline('  ')

	rankPopup.send(userid)

#hitbox
def showhitbox(userid):
	#SELECT ifnull( wp.name, wp.uniqueid ) weapon, SUM( w.shot_head ) shot_head, SUM( w.shot_chest ) shot_chest, SUM( w.shot_stomach ) shot_stomach, SUM( w.shot_leftarm ) shot_leftarm, SUM( w.shot_rightarm ) shot_rightarm, SUM( w.shot_leftleg ) shot_leftleg, SUM( w.shot_rightleg ) shot_rightleg, SUM( w.shot_head + w.shot_chest + w.shot_stomach + w.shot_leftarm + w.shot_rightarm + w.shot_leftleg + w.shot_rightleg ) totalshots
	#FROM `ps_plr_weapons` w, `ps_weapon` wp
	#WHERE plrid =5
	#AND wp.weaponid = w.weaponid
	#GROUP BY ifnull( wp.name, wp.uniqueid )
	#ORDER BY totalshots
	global sql_c
	global pfx
	cst.checkDBconn()
	q = sql_c.cursor()
	q.execute("SELECT 'All weapons' weapon, SUM( w.shot_head ) shot_head, SUM( w.shot_chest ) shot_chest, SUM( w.shot_stomach ) shot_stomach, SUM( w.shot_leftarm ) shot_leftarm, SUM( w.shot_rightarm ) shot_rightarm, SUM( w.shot_leftleg ) shot_leftleg, SUM( w.shot_rightleg ) shot_rightleg, SUM( w.shot_head + w.shot_chest + w.shot_stomach + w.shot_leftarm + w.shot_rightarm + w.shot_leftleg + w.shot_rightleg ) totalshots FROM `"+pfx+"plr_weapons` w WHERE w.plrid = (SELECT plrid FROM "+pfx+"plr WHERE uniqueid = '"+cst.getUniqueId(userid)+"') ")
	c = q.fetchone()
	weapon_name = c[0]
	shot_head = c[1]
	shot_chest = c[2]
	shot_stomach = c[3]
	shot_leftarm = c[4]
	shot_rightarm = c[5]
	shot_leftleg = c[6]
	shot_rightleg = c[7]
	total_shot = c[8]
	total_shots = total_shot
	if total_shot==0:
		total_shot=1
	shot_head_pct = "%02d" % round(shot_head/total_shot*100,0)
	shot_chest_pct = "%02d" % round(shot_chest/total_shot*100,0)
	shot_stomach_pct = "%02d" % round(shot_stomach/total_shot*100,0)
	shot_leftarm_pct = "%02d" % round(shot_leftarm/total_shot*100,0)
	shot_rightarm_pct = "%02d" % round(shot_rightarm/total_shot*100,0)
	shot_leftleg_pct = "%02d" % round(shot_leftleg/total_shot*100,0)
	shot_rightleg_pct = "%02d" % round(shot_rightleg/total_shot*100,0)

	rankPopup = popuplib.create('hitbox_popup')
	rankPopup.addline('->1 - ' + langs("hitbox",{},plr.get("lang")) +' : ' + weapon_name)
	rankPopup.addline('-------------------------------')
	rankPopup.addline('    '+langs("head",{},plr.get("lang"))+'       : ' + str(shot_head_pct)+'% ('+str(shot_head)+' ' + langs("shots",{},plr.get("lang")) + ')')
	rankPopup.addline('    '+langs("chest",{},plr.get("lang"))+'      : ' + str(shot_chest_pct)+'% ('+str(shot_chest)+' ' + langs("shots",{},plr.get("lang")) + ')')
	rankPopup.addline('    '+langs("stomach",{},plr.get("lang"))+' : ' + str(shot_stomach_pct)+'% ('+str(shot_stomach)+' ' + langs("shots",{},plr.get("lang")) + ')')
	rankPopup.addline('    '+langs("leftarm",{},plr.get("lang"))+'  : ' + str(shot_leftarm_pct)+'% ('+str(shot_leftarm)+' ' + langs("shots",{},plr.get("lang")) + ')')
	rankPopup.addline('    '+langs("rightarm",{},plr.get("lang"))+': ' + str(shot_rightarm_pct)+'% ('+str(shot_rightarm)+' ' + langs("shots",{},plr.get("lang")) + ')')
	rankPopup.addline('    '+langs("leftleg",{},plr.get("lang"))+'   : ' + str(shot_leftleg_pct)+'% ('+str(shot_leftleg)+' ' + langs("shots",{},plr.get("lang")) + ')')
	rankPopup.addline('    '+langs("rightleg",{},plr.get("lang"))+' : ' + str(shot_rightleg_pct)+'% ('+str(shot_rightleg)+' ' + langs("shots",{},plr.get("lang")) + ')')
	rankPopup.addline('-------------------------------')
	rankPopup.addline('    '+langs("totalshots",{},plr.get("lang"))+' : ' + str(total_shots))
	rankPopup.addline('    ')
	rankPopup.addline('->0 - '+langs("exit",{},plr.get("lang")))
	rankPopup.send(userid)
	return 1


# ================================================================================== #
# ================================= Game Events ==================================== #
# ================================================================================== #

#def player_connect(ev):
	#	anounce_player_connect(ev['userid'])
	#plr			= playerlib.getPlayer(int(ev['userid']))
	#es.mess('Player language is :' + str(plr.get("lang")))

def player_activate(ev):
	global plrsets, rtc_calc_enabled, ps_stats_include_bots
	anounce_player_connect(ev['userid'])
	stats.setPlayerProps(ev['userid'])
	# Check, if players can static, then start it
	rtc = rtc_calc_enabled
	rtc2 = stats.setStatsEnabled()
	if ( (rtc2 == 0) and ( (es.isbot(ev['userid'])==0) or (ps_stats_include_bots==1) ) ):
		cst.langmsg("pswillnotstart",{"minplrs":str(ps_stats_minplayers)})
	if rtc == 0 and rtc2 == 1:
		cst.langmsg("psstart",{})


def player_disconnect(ev):
	global rtc_calc_enabled
	userid 		= ev['userid']
	uid			= cst.getUniqueId(userid)
	rtc = rtc_calc_enabled
	rtc2 = stats.setStatsEnabled()
	if rtc == 1 and rtc2 == 0:
		cst.langmsg("psstop",{})

def player_death(ev):
	rtc_calc_points(ev['userid'],ev['attacker'],ev['weapon'],ev['headshot'])

def round_start(ev):
	global bomb_planter_id
	bomb_planter_id = 0
	# When round start, rebalance
	atb('round_start')

def round_end(ev):
	if ev['reason']=='1': # Target bombed #
		event_bonus('target_bombed',ev)
	elif ev['reason']=='2': # VIP_Escaped #
		event_bonus('vip_escaped',ev)
	elif ev['reason']=='3': # VIP_Assassinated #
		event_bonus('vip_assassinated',ev)
	#elif ev['reason']=='4': # Terrorists_Escaped
	#	event_bonus('???',ev)
	#elif ev['reason']=='5': # CTs_PreventEscape
	#	event_bonus('???',ev)
	#elif ev['reason']=='6': # #Escaping_Terrorists_Neutralized
	#	event_bonus('???',ev)
	elif ev['reason']=='7': # Bomb defused #
		event_bonus('bomb_defused',ev)
	elif ev['reason']=='8':	# #CTs_Win #
		event_bonus('round_win',ev)
	elif ev['reason']=='9':	# Terrorists_Win #
		event_bonus('round_win',ev)
	#elif ev['reason']=='10': # Round_Draw #
	#	event_bonus('???',ev)
	elif ev['reason']=='11': # Hostages Rescued #
		event_bonus('all_hostages_rescued',ev)
	elif ev['reason']=='12': # Target_Saved #
		event_bonus('target_saved',ev)
	elif ev['reason']=='13': # Hostages not Rescued #
		event_bonus('hostages_not_rescued',ev)
	#elif ev['reason']=='14': # Terrorists_Not_Escaped #
	#	event_bonus('???',ev)
	elif ev['reason']=='15': # VIP_Not_Escaped #
		event_bonus('vip_not_escaped',ev)
	cst.checkDBconn()


def bomb_planted(ev):
	#ev['message'] = 'Planted the Bomb'
	event_bonus('planted_the_bomb',ev)
def bomb_defused(ev):
	#ev['message'] = 'Defused the Bomb'
	event_bonus('defused_the_bomb',ev)
def hostage_rescued(ev):
	#ev['message'] = 'Rescued a hostage'
	event_bonus('rescued_a_hostage',ev)
def hostage_killed(ev):
	#ev['message'] = 'Killed a hostage'
	event_bonus('killed_a_hostage',ev)

#Bomb abortdefuse
#Bomb abortplant
#Bomb begindefuse
#Bomb beginplant
#Bomb defused
#Bomb dropped
#Bomb exploded
#Bomb pickup
#Bomb planted

def es_map_start(ev):
	#Recalculate WebPsychoStats by psychostats perl script
	webPSstats()

# ================================================================================== #
# =========================== Global Functions Block =============================== #
# ================================================================================== #

def anounce_player_connect(userid):
	global ps_stats_base_skill, ps_admin_anounce
	if es.isbot(userid) <> 1:
		uid	= cst.getUniqueId(userid)
		data = stats.getPlayerData(uid)
		name = es.getplayername(userid)
		if uid in admin_list and ps_admin_anounce==1:
			adm = 1
			sfx = "#lightgreen[ADMIN]#default"
		else:
			adm = 0
			sfx = ""
		try:
			skill = data[3]
		except:
			skill = ps_stats_base_skill
		plr = playerlib.getPlayer(userid)
		ip = plr.attributes['address']
		if ip[0:3]=='10.':
			country = 'Local-Lan'
		elif ip[0:3]=='172':
			country = 'LocalProvider'
		elif ip[0:3]=='192':
			country = 'LocalProvider'
		else:
			country = stats.getPlayerCountry(ip)
		if country=='':
			country = 'Unknown'
		cst.langmsg("psconnect",{"sfx":str(sfx),"name":str(name),"steam":str(es.getplayersteamid(userid)), "country":str(country),"place":str(data[1]),"skill":str(skill)})

def cmdAnounce():
	global ps_cmd_top, ps_cmd_session, ps_cmd_statsme, ps_cmd_kpd, ps_cmd_rank, ps_cmd_anounce
	if ps_cmd_anounce==1:
		cst.langmsg("pscmds",{"cmdlist":str(ps_cmd_top + ", " + ps_cmd_rank + ", " + ps_cmd_statsme + ", " + ps_cmd_session + ", " + ps_cmd_kpd)})

# ================================================================================== #
# ========================= WebStats Recalculate Block ============================= #
# ================================================================================== #
def webPSstats():
	global ps_os_stats_path,ps_webstats_recalc
	if ps_webstats_recalc==1:
		if os.name=='nt':
			os.system('C:/Perl/Bin/Perl.exe ' + ps_os_stats_path)
		elif os.name=='posix':
			os.system('/usr/bin/perl ' + ps_os_stats_path)

# ================================================================================== #
# =========================== Auto Team Balance Block ============================== #
# ================================================================================== #
def atb(cause='unknown'):
	global ps_atb, ps_atb_minplayers, ps_atb_attempts, atb_rounds
	if ps_atb>0 and es.getplayercount()>=ps_atb_minplayers:
		atb_calc_balance()
		if ps_atb==1:
			show_team_balance()
		if ps_atb==2 and cause=='round_start':
			atb_rounds = atb_rounds + 1
			if atb_rounds >= ps_atb_attempts:
				atb_rounds = 0
				res = atb_swap()
			else:
				if ps_atb_anounce>=2:
					cst.langmsg("psatbanounce1",{"att":str(ps_atb_attempts-atb_rounds)})
			show_team_balance()
		if ps_atb==3 and cause=='timer':
			res = atb_swap()
			cst.langmsg("psatbanounce2",{"att":str(ps_atb_attempts-atb_rounds)})
			show_team_balance()

def atb_calc_balance():
	global team_kdr_t, team_kdr_ct, team_t_plrs, team_ct_plrs
	team_kdr_t = 0
	team_kdr_ct = 0
	team_t_plrs = 0
	team_ct_plrs = 0
	myPlayerList = playerlib.getPlayerList('#all')
	for ply in myPlayerList:
		userid = int(ply.userid)
		name = es.getplayername(userid)
		uid	= cst.getUniqueId(userid)
		try:
			kdr = plrsets[uid,'kdr']
		except:
			if not es.isbot(userid) or ps_stats_include_bots==1:
				data = stats.getPlayerData(uid)
				try:
					plr_kills = data[6]
					plr_deaths	= data[7]
				except:
					plr_kills = 1
					plr_deaths	= 1
			else:
				plr_kills = 1
				plr_deaths	= 1
			if (plr_deaths == 0):
				kdr = 0
			else:
				kdr = float(plr_kills)/float(plr_deaths)
			if (es.isbot(userid)) and (ps_stats_include_bots == 0):
				if bots.getKpd(userid):
					kdr = bots.getKpd(userid)
				else:
					kdr = 0.6
			#cst.log('kdr =' + str(kdr))
			plrsets[uid,'kdr'] = kdr
		if ply.attributes['teamid']== 2:
			team_t_plrs = team_t_plrs + 1
			team_kdr_t = team_kdr_t + kdr
		if ply.attributes['teamid']== 3:
			team_ct_plrs = team_ct_plrs + 1
			team_kdr_ct = team_kdr_ct + kdr

def show_team_balance():
	global team_kdr_t, team_kdr_ct, ps_atb_anounce
	if ps_atb_anounce>=1:
		cst.langmsg("psatbbalance",{"team_kdr_t":str("%.2f" % round(team_kdr_t,2)),"team_kdr_ct":"%.2f" % round(team_kdr_ct,2)})

def atb_swap():
	global team_kdr_t, team_kdr_ct, team_ct_plrs, team_t_plrs
	global plrsets
	global ps_atb
	global ps_atb_minplayers
	global ps_atb_diff
	global ps_atb_mover
	global ps_stats_include_bots
	global ps_atb_anounce
	swap = 0
	swaped = 0
	if ps_atb>0 and es.getplayercount()>=ps_atb_minplayers:
		team_new_kdr_t = team_kdr_t
		team_new_kdr_ct = team_kdr_ct
		swap = 0
		swaped = 0
		min_atb_diff = abs(team_kdr_t - team_kdr_ct)
		if team_kdr_t> team_kdr_ct + ps_atb_diff:
			swap = 1
			swap_plrs = {'ct':-1,'ct2':-1,'t':-1,'t2':-1,'diff':min_atb_diff}
			pListT = playerlib.getPlayerList('#t')
			for plyT in pListT:
				Tuid = cst.getUniqueId(int(plyT.userid))
				T_kdr = plrsets[Tuid,'kdr']
				#check if needed move 1 terr
				if team_t_plrs>team_ct_plrs:
					diff = abs((team_kdr_ct + T_kdr) - (team_kdr_t - T_kdr))
					if diff < swap_plrs['diff']:
						swap_plrs['t'] = int(plyT.userid)
						swap_plrs['ct'] = -1
						swap_plrs['diff'] = diff
						team_new_kdr_t = team_kdr_t - T_kdr
						team_new_kdr_ct = team_kdr_ct + T_kdr
				#check if needed move 1 terr and 1 ct
				pListCT = playerlib.getPlayerList('#ct')
				for plyCT in pListCT:
					CTuid = cst.getUniqueId(int(plyCT.userid))
					CT_kdr = plrsets[CTuid,'kdr']
					diff = abs((team_kdr_ct + T_kdr - CT_kdr) - (team_kdr_t + CT_kdr - T_kdr))
					if diff < swap_plrs['diff']:
						swap_plrs['t'] = int(plyT.userid)
						swap_plrs['ct'] = int(plyCT.userid)
						swap_plrs['diff'] = diff
						team_new_kdr_t = team_kdr_t - T_kdr + CT_kdr
						team_new_kdr_ct = team_kdr_ct - CT_kdr + T_kdr
			if swap_plrs['t']<>-1:
				if ps_atb_anounce>=1:
					cst.langmsg("psatbmovedtoct",{"plr":str(es.getplayername(swap_plrs['t']))})
				if ps_atb_mover==1:
					cst.changeteam(swap_plrs['t'],'3')
					swaped = 1
			else:
				if ps_atb_anounce>=2:
					cst.langmsg("psatbnomove",{})
			if swap_plrs['ct']<>-1:
				if ps_atb_anounce>=1:
					cst.langmsg("psatbmovedtot",{"plr":str(es.getplayername(swap_plrs['ct']))})
				if ps_atb_mover==1:
					cst.changeteam(swap_plrs['ct'],'2')



		if team_kdr_ct> team_kdr_t + ps_atb_diff:
			swap = 1
			swap_plrs = {'ct':-1,'ct2':-1,'t':-1,'t2':-1,'diff':min_atb_diff}
			pListCT = playerlib.getPlayerList('#ct')
			for plyCT in pListCT:
				CTuid = cst.getUniqueId(int(plyCT.userid))
				CT_kdr = plrsets[CTuid,'kdr']
				#check swap 1 ct
				if team_ct_plrs>=team_t_plrs:
					diff = abs((team_kdr_t + CT_kdr) - (team_kdr_ct - CT_kdr))
					if diff < swap_plrs['diff']:
						swap_plrs['ct'] = int(plyCT.userid)
						swap_plrs['diff'] = diff
						team_new_kdr_t = team_kdr_t + CT_kdr
						team_new_kdr_ct = team_kdr_ct - CT_kdr
				#check swap 1 t and 1 ct
				pListT = playerlib.getPlayerList('#t')
				for plyT in pListT:
					Tuid = cst.getUniqueId(int(plyT.userid))
					T_kdr = plrsets[Tuid,'kdr']
					diff = abs((team_kdr_t + CT_kdr - T_kdr) - (team_kdr_ct + T_kdr - CT_kdr))
					if diff < swap_plrs['diff']:
						swap_plrs['t'] = int(plyT.userid)
						swap_plrs['ct'] = int(plyCT.userid)
						swap_plrs['diff'] = diff
						team_new_kdr_t = team_kdr_t - T_kdr + CT_kdr
						team_new_kdr_ct = team_kdr_ct - CT_kdr + T_kdr
			if swap_plrs['ct']<>-1:
				if ps_atb_anounce>=1:
					cst.langmsg("psatbmovedtot",{"plr":str(es.getplayername(swap_plrs['ct']))})
				if ps_atb_mover==1:
					cst.changeteam(swap_plrs['ct'],'2')
					swaped = 1
			else:
				if ps_atb_anounce>=2:
					cst.langmsg("psatbnomove",{})
			if swap_plrs['t']<>-1:
				if ps_atb_anounce>=1:
					cst.langmsg("psatbmovedtoct",{"plr":str(es.getplayername(swap_plrs['t']))})
				if ps_atb_mover==1:
					cst.changeteam(swap_plrs['t'],'3')

		if swap == 0:
			if ps_atb_anounce>=1:
				cst.langmsg("psatbbalanced",{})
		team_kdr_t = team_new_kdr_t
		team_kdr_ct = team_new_kdr_ct
	return swaped

# ================================================================================== #
# ========================== RealTime Calculation Block ============================ #
# ================================================================================== #
def rtc_calc_points(victim_userid,attacker_userid,weapon_id,headshot):
	global ps_weapon_bonus, ps_event_bonus, ps_stats_base_skill, ps_stats_maxpoints, ps_stats_headshotbonus,ps_stats_multiplier, plrsets
	global ps_skilldiff_anounce, rtc_calc_enabled
	# If rtc_calc is disabled then exit
	if rtc_calc_enabled==0:
		return 0
	action = 'none'
	if victim_userid == attacker_userid:
		action = 'suicide'
		if ps_skilldiff_anounce==1:
			plr = playerlib.getPlayer(attacker_userid)
			es.tell(attacker_userid,"#multi", langs("psrtcsuicide",{"pts":str(abs(ps_event_bonus['suicide']['enactor']))},plr.get("lang")))
		stats.registerPlayerProp(attacker_userid,'skill',ps_event_bonus['suicide']['enactor'])
		stats.registerPlayerProp(victim_userid,'s_deaths',1)
	elif es.getplayerteam(victim_userid) == es.getplayerteam(attacker_userid):
		action = 'teamkill'
		if ps_skilldiff_anounce==1:
			plr = playerlib.getPlayer(attacker_userid)
			es.tell(attacker_userid,"#multi", langs("psrtcteamkill",{"pts":str(abs(ps_event_bonus['suicide']['enactor'])),"plr":str(es.getplayername(victim_userid))},plr.get("lang")))
		stats.registerPlayerProp(attacker_userid,'skill',ps_event_bonus['ffkill']['enactor'])
		stats.registerPlayerProp(victim_userid,'s_kills',-1)
	else:
		action = 'frag'
		victim_bonus = 1.0
		attacker_bonus = 1.0

		attacker_skill = plrsets[cst.getUniqueId(attacker_userid),'skill']
		victim_skill = plrsets[cst.getUniqueId(victim_userid),'skill']
		# ex 4095 3222  atckr =  1.78 vctm = 0.79
		if attacker_skill > victim_skill:
			attacker_bonus = max(attacker_skill + victim_skill,2.0) / max (attacker_skill, 2.0)
			victim_bonus = attacker_bonus * victim_skill / max(victim_skill + attacker_skill,2.0)
		else:
		# ex 3222 4095 atckr =  2.27 vctm =  1.59
			attacker_bonus = max(attacker_skill + victim_skill,2.0) / max (victim_skill, 2.0) * victim_skill / max (attacker_skill, 2.0)
			victim_bonus = attacker_bonus * (victim_skill + ps_stats_base_skill) / max(victim_skill + attacker_skill,2.0)
		#attacker_bonus = attacker_bonus * ps_stats_multiplier
		#victim_bonus = victim_bonus * ps_stats_multiplier
		#add headshotbonus
		attacker_bonus = attacker_bonus + int(headshot) * ps_stats_headshotbonus
		victim_bonus = victim_bonus + int(headshot) * ps_stats_headshotbonus
		#add weaponbonus
		attacker_bonus = attacker_bonus *ps_weapon_bonus[weapon_id]
		victim_bonus = victim_bonus *ps_weapon_bonus[weapon_id]

		if attacker_bonus > ps_stats_maxpoints:
			attacker_bonus = ps_stats_maxpoints
		if victim_bonus > ps_stats_maxpoints:
			victim_bonus = ps_stats_maxpoints
		if attacker_bonus > attacker_skill:
			attacker_bonus = attacker_skill
		if victim_bonus > victim_skill:
			victim_bonus = 1.0
		#round bonus
		attacker_bonus = round(attacker_bonus,2)
		victim_bonus = round(victim_bonus,2)
		#colors
		if es.getplayerteam(attacker_userid)==2:
			attacker_color ='#lightgreen'
			victim_color = '#lightgreen'
		else:
			attacker_color ='#lightgreen'
			victim_color = '#lightgreen'
		if ps_skilldiff_anounce==1:
			plr = playerlib.getPlayer(attacker_userid)
			es.tell(attacker_userid,"#multi", langs("psrtcattacker",{"attacker_color":str(attacker_color),"aplr":es.getplayername(attacker_userid),"askill":str(attacker_skill),"bonus":str(attacker_bonus),"victim_color":str(victim_color),"vplr":str(es.getplayername(victim_userid)),"vskill":str(victim_skill),"weapon":str(weapon_id)},plr.get("lang")))
			plr = playerlib.getPlayer(victim_userid)
			es.tell(victim_userid,"#multi", langs("psrtcattacker",{"attacker_color":str(attacker_color),"aplr":es.getplayername(attacker_userid),"askill":str(attacker_skill),"bonus":str(attacker_bonus),"victim_color":str(victim_color),"vplr":str(es.getplayername(victim_userid)),"vskill":str(victim_skill),"weapon":str(weapon_id)},plr.get("lang")))
		cst.log(es.getplayername(attacker_userid) + " (" + str(attacker_skill) + ' pts) received ' + str(attacker_bonus) + " points for killing " + es.getplayername(victim_userid) + " (" + str(victim_skill) + "pts) with a " +str(weapon_id)+ ".")
		# registration points
		stats.registerPlayerProp(attacker_userid,'skill',attacker_bonus)
		stats.registerPlayerProp(victim_userid,'skill',-victim_bonus)
		stats.registerPlayerProp(attacker_userid,'s_kills',1)
		stats.registerPlayerProp(victim_userid,'s_deaths',1)
		if int(headshot)==1:
			stats.registerPlayerProp(attacker_userid,'s_headshots',1)


	return 1
# ==============  R o u n d   S p e c i f i c   P o i n t s F u n c.  =============== #

def event_bonus(event,ev):
	global ps_event_bonus, bomb_planter_id, ps_skilldiff_anounce
	global rtc_calc_enabled
	# If rtc_calc is disabled then exit
	if rtc_calc_enabled==0:
		return 0
	victim_userid = 0
	if event=='planted_the_bomb':
		bomb_planter_id = ev['userid']
	if event=='defused_the_bomb':
		victim_userid = bomb_planter_id
	if ev['userid']:
		enactor_userid = int(ev['userid'])
	else:
		enactor_userid = 0
	if ev['winner']:
		enactor_team = int(ev['winner'])
	else:
		enactor_team = es.getplayerteam(ev['userid'])
	victim_team = 5 - int(enactor_team)

	enactor_plr_pts = ps_event_bonus[event]['enactor']
	enactor_team_pts = ps_event_bonus[event]['enactor_team']
	victim_plr_pts = ps_event_bonus[event]['victim']
	victim_team_pts = ps_event_bonus[event]['victim_team']

	if enactor_plr_pts!=0 and enactor_userid>0:
		if enactor_plr_pts>0:
			tmess = 'received'
		else:
			tmess = 'loss'
		if ps_skilldiff_anounce==1:
			plr = playerlib.getPlayer(enactor_userid)
			tmess = langs(tmess,{},plr.get("lang"))
			es.tell(enactor_userid,"#multi", langs("psrtcbonus",{"tmess":tmess,"pts":str(enactor_plr_pts),"event":ps_event_bonus[event]['message']},plr.get("lang")))
		stats.registerPlayerProp(enactor_userid,'skill',enactor_plr_pts)
	if victim_plr_pts!=0 and victim_userid>0:
		if victim_plr_pts>0:
			tmess = 'received'
		else:
			tmess = 'loss'
		if ps_skilldiff_anounce==1:
			plr = playerlib.getPlayer(victim_userid)
			tmess = langs(tmess,{},plr.get("lang"))
			es.tell(victim_userid,"#multi", langs("psrtcbonus",{"tmess":tmess,"pts":str(victim_plr_pts),"event":ps_event_bonus[event]['message']},plr.get("lang")))
		stats.registerPlayerProp(victim_userid,'skill',victim_plr_pts)
	if enactor_team_pts!=0:
		if enactor_team_pts>0:
			tmess_en = 'received'
		else:
			tmess_en = 'loss'
		if enactor_team==3:
			team = '#ct'
			team_d = 'Counter-Terrorist'
		else:
			team = '#t'
			team_d = 'Terrorist'
		pList = playerlib.getPlayerList(team)
		for ply in pList:
			if ps_skilldiff_anounce==1:
				index = ply.attributes['index']
				tmess = langs(tmess_en,{},ply.get("lang"))
				usermsg.saytext2(int(ply.userid),index,'\x04[PS-STATS]: \x03 ' + team_d + " \x01 " + tmess + " \x04" + str(abs(enactor_team_pts)) + "\x01 " + langs("pointsfor",{},ply.get("lang")) + " \x04" + ps_event_bonus[event]['message'],'','','','')

			stats.registerPlayerProp(int(ply.userid),'skill',enactor_team_pts)
	if victim_team_pts!=0:
		if victim_team_pts>0:
			tmess_en = 'received'
		else:
			tmess_en = 'loss'
		if victim_team==3:
			team = '#ct'
			team_d = 'Counter-Terrorist'
		else:
			team = '#t'
			team_d = 'Terrorist'
		pList = playerlib.getPlayerList(team)
		for ply in pList:
			if ps_skilldiff_anounce==1:
				index = ply.attributes['index']
				tmess = langs(tmess_en,{},ply.get("lang"))
				usermsg.saytext2(int(ply.userid),index,'\x04[PS-STATS]: \x03 ' + team_d + "\x01 " + tmess + " \x04" + str(abs(victim_team_pts)) + "\x01 " + langs("pointsfor",{},ply.get("lang")) + " \x04" + ps_event_bonus[event]['message'],'','','','')
			stats.registerPlayerProp(int(ply.userid),'skill',victim_team_pts)




# ================================================================================== #
# =================== A d d o n   C l a s s e s   L i b r a r y ==================== #
# ================================================================================== #
class stats(object):

	def getPlayerData(self, uid):
		cst.checkDBconn()
		global pfx
		q = sql_c.cursor()
		query = ' SELECT pl.plrid, pl.rank, pl.prevrank, pl.skill, pl.prevskill, ( SELECT COUNT( plrid ) cnt FROM `'+pfx+'plr`) AS plr_cnt, pld.kills, pld.deaths, pld.hskills, pld.ffkills, pld.ffdeaths, pld.kills_streak, pld.deaths_streak, pld.suicides, pld.games, pld.rounds, pld.onlinetime, pld.ctkills , pld.terroristkills, pld.ctdeaths, pld.terroristdeaths, pld.bomd_def_att, pld.bomd_def, pld.bomb_exp, pld.bomb_pl, pld.bomd_sp, pld.killhost, pld.reschost, pld.touchhost, pld.ctwon, pld.ctlost, pld.twon,  pld.tlost, (ps.skill - ps.prevskill) s_points, ps.kills s_kills, ps.deaths s_deaths, ps.headshotkills s_hk, ps.ffkills s_ffkills, ps.ffdeaths s_ffdeaths, ps.suicides s_suicides '
		query = query + ' FROM `'+pfx+'plr` pl, `'+pfx+'plr_sessions` ps, ( SELECT pdt.plrid, SUM( pdt.kills ) kills, SUM( pdt.deaths ) deaths, SUM(pdt.headshotkills) hskills,SUM( pdt.ffkills ) ffkills, SUM( pdt.ffdeaths ) ffdeaths, MAX( pdt.kills_streak ) kills_streak, MAX( pdt.deaths_streak ) deaths_streak, SUM( pdt.suicides ) suicides, SUM( pdt.games ) games, SUM( pdt.rounds ) rounds, SUM( pdt.onlinetime ) onlinetime, SUM(pdts.ctkills) ctkills ,SUM(pdts.terroristkills) terroristkills,SUM(pdts.ctdeaths) ctdeaths,SUM(pdts.terroristdeaths) terroristdeaths,SUM(pdts.bombdefuseattempts) bomd_def_att,SUM(pdts.bombdefused) bomd_def,SUM(pdts.bombexploded) bomb_exp,SUM(pdts.bombplanted) bomb_pl,SUM(pdts.bombspawned) bomd_sp,SUM(pdts.killedhostages) killhost '
		query = query + ' , SUM(pdts.rescuedhostages) reschost,SUM(pdts.touchedhostages) touchhost, SUM(pdts.ctwon) ctwon,SUM(pdts.ctlost) ctlost,SUM(pdts.terroristwon) twon, SUM(pdts.terroristlost) tlost FROM `'+pfx+'plr_data` pdt, `'+pfx+'plr_data_halflife_cstrike` pdts WHERE pdts.dataid = pdt.dataid GROUP BY pdt.plrid)pld WHERE ps.plrid = pl.plrid AND pl.uniqueid = "'+str(uid)+'" AND ps.dataid = (SELECT MAX( dataid ) FROM `'+pfx+'plr_sessions` psm WHERE psm.plrid = pl.plrid ) AND pld.plrid = pl.plrid '
		q.execute(query)
		n = int(q.rowcount)
		if(n < 1):
			data = '-1'
		else:
			data = q.fetchone()
		q.close()
		return data

	def getPlayerCountry(self,ip):
		cst.checkDBconn()
		global pfx
		q = sql_c.cursor()
		query = 'SELECT gcc.cn FROM `ps_geoip_ip` gip, `ps_geoip_cc` gcc WHERE inet_aton("'+ ip +'") BETWEEN `start` AND `end` AND gcc.cc = gip.cc'
		q.execute(query)
		n = int(q.rowcount)
		if(n < 1):
			q.close()
			return ''
		else:
			data = q.fetchone()
			q.close()
			return data[0]

	def setPlayerProps(self,user_id):
		global prlsets, ps_stats_base_skill
		if user_id == 0:
			myPlayerList = playerlib.getPlayerList('#all')
			for ply in myPlayerList:
				uid	= cst.getUniqueId(int(ply.userid))
				data = self.getPlayerData(uid)
				try:
					plrsets[uid,'skill'] = data[3]
				except:
					plrsets[uid,'skill'] = ps_stats_base_skill
				plrsets[uid,'s_kills'] = 0
				plrsets[uid,'s_deaths'] = 0
				plrsets[uid,'s_headshots'] = 0
		else:
			ply = playerlib.getPlayer(user_id)
			uid	= cst.getUniqueId(int(ply.userid))
			data = self.getPlayerData(uid)
			try:
				plrsets[uid,'skill'] = data[3]
			except:
				plrsets[uid,'skill'] = ps_stats_base_skill
			plrsets[uid,'s_kills'] = 0
			plrsets[uid,'s_deaths'] = 0
			plrsets[uid,'s_headshots'] = 0

	def registerPlayerProp(self,user_id,prop,value):
		uid	= cst.getUniqueId(user_id)
		plrsets[uid,prop] = plrsets[uid,prop] + value

	def setStatsEnabled(self):
		global ps_stats_minplayers, ps_stats_include_bots, rtc_calc_enabled
		plrcnt = 0
		if ps_stats_include_bots == 1:
			myPlayerList = playerlib.getPlayerList('#all')
		else:
			myPlayerList = playerlib.getPlayerList('#human')
		for ply in myPlayerList:
			if ply.attributes['teamid']==2 or ply.attributes['teamid']==3:
				plrcnt = plrcnt+1
		if plrcnt>=ps_stats_minplayers:
			rtc_calc_enabled = 1
		else:
			rtc_calc_enabled = 0
		return rtc_calc_enabled

stats = stats()

class cst(object):
	def init(self):
		self.log('-- Psychostats 3.1 - Ranks & Statistics Modification for CS:Source Servers --')
		self.mysql_connect()
		self.mysql_init()
		self.preloadSettings()
		self.preloadPlrData()
		stats.setStatsEnabled()

	def close(self):
		global sql_c
		sql_c.close()

	def checkDBconn(self):
		q = sql_c.cursor()
		try:
			sql_c.ping()
			q.execute('SELECT 1')
		except:
			self.mysql_connect()
			self.mysql_init()
		q.close()

	def log(self, msg):
		es.dbgmsg(0, msg);

	def langmsg(self,msg,attr = {}):
		myPlayerList = playerlib.getPlayerList('#human')
		for ply in myPlayerList:
			es.tell(int(ply.userid),'#multi',langs(msg,attr,ply.get("lang")))

	def mysql_connect(self):
		global sql_c
		self.log('Attempting to connect to [' + str(ps_mysql_hostname)+ ']...')
		try:
			sql_c = MySQLdb.connect(ps_mysql_hostname, ps_mysql_username, ps_mysql_password, ps_mysql_database)
			if(sql_c):
				self.log('Successfully connected to '+str(ps_mysql_hostname)+' with username "'+str(ps_mysql_username)+'".')

		except MySQLdb.Error, e:
			self.log('ERROR: Could not connect to the MySQL Server!')
			self.log('ERROR: ' + str(e))
			#es.unload(info.basename) # if mysql-server fails - we dont need stop plugin - plugin reconect when mysql restored
			return

	def mysql_init(self):
		q = sql_c.cursor()
		q.execute('SET NAMES "UTF8"');
		q.execute('SET collation_connection="cp1251_general_ci"')
		q.execute('SET collation_server="cp1251_general_ci"')
		q.execute('SET character_set_client="utf8"')
		q.execute('SET character_set_connection="utf8"')
		q.execute('SET character_set_results="utf8"')
		q.execute('SET character_set_server="cp1251"')
		q.close()

	def preloadSettings(self):
		q = sql_c.cursor()
		global ps_stats_calc_mode, ps_stats_include_bots, ps_stats_minplayers, ps_stats_maxdays, ps_stats_max_pl_sess
		global pfx
		# MAIN SETTINGS
		q.execute('SELECT var, value FROM `'+pfx+'config` WHERE (section is null or section="") AND var is not null')
		numrows = int(q.rowcount)
		for x in range(0, numrows):
			c = q.fetchone()
			if (c[0]== 'uniqueid' ):
				if (c[1]=='worldid'):
					ps_stats_calc_mode = 1
				elif (c[1]=='name'):
					ps_stats_calc_mode = 2
				elif (c[1]=='ipaddr'):
					ps_stats_calc_mode = 3
			if (c[0]== 'ignore_bots' ):
				if (c[1]=='1'):
					ps_stats_include_bots = 0
				else:
					ps_stats_include_bots = 1
			if (c[0]== 'maxdays' ):
				ps_stats_maxdays = c[1]
			if (c[0]== 'plr_sessions_max' ):
				ps_stats_max_pl_sess = int(c[1])
			if (c[0]== 'baseskill' ):
				ps_stats_base_skill = int(c[1])
			if (c[0]== 'minconnected' ):
				ps_stats_minplayers = int(c[1])


		# BONUS POINTS
		global ps_event_bonus
		q.execute('SELECT eventname, enactor, enactor_team, victim, victim_team FROM `'+pfx+'config_plrbonuses` WHERE modtype = "" OR modtype = "cstrike"')
		numrows = int(q.rowcount)
		for x in range(0, numrows):
			c = q.fetchone()
			if ps_event_bonus[c[0]]:
				ps_event_bonus[c[0]]['enactor'] = c[1]
				ps_event_bonus[c[0]]['enactor_team'] = c[2]
				ps_event_bonus[c[0]]['victim'] = c[3]
				ps_event_bonus[c[0]]['victim_team'] = c[4]

		# WEAPON POINTS
		global ps_weapon_bonus
		q.execute('SELECT uniqueid, ifnull(skillweight,0) sw FROM `'+pfx+'weapon`')
		numrows = int(q.rowcount)
		for x in range(0, numrows):
			c = q.fetchone()
			pts = float(c[1])
			if pts!=0:
				ps_weapon_bonus[c[0]]=pts

		q.close()

		#setup player ingame attributes
		stats.setPlayerProps(0)

	def getAdminList(self):
		global admin_list, ps_stats_calc_mode
		es.keygroupcreate("clients")
		clients = keyvalues.getKeyGroup("clients")
		try:
			#server var mani_admin_plugin_version
			clients.load("cfg/mani_admin_plugin/clients.txt")
		except:
			return 0
		if ps_stats_calc_mode == 1:
			try:
				admin_list = admin_list + [x['steam'] for x in clients['players']]
			except:
				admin_list = admin_list
		if ps_stats_calc_mode == 2:
			try:
				admin_list = admin_list + [x['name'] for x in clients['players']]
			except:
				admin_list = admin_list
		if ps_stats_calc_mode == 3:
			try:
				admin_list = admin_list + [x['ip'] for x in clients['players']]
			except:
				admin_list = admin_list

		#es.dbgmsg(0, admin_list)

	def getUniqueId(self, userid):
		global ps_stats_calc_mode
		if es.isbot(userid) == 1:
			return str(es.getplayername(userid))
		elif (ps_stats_calc_mode == 1):
			return str(es.getplayersteamid(userid))
		elif (ps_stats_calc_mode == 2):
			return str(es.getplayername(userid))
		else:
			plr = playerlib.getPlayer(userid)
			#return str(plr.attributes['address']) --normal ip
			#return str(struct.unpack('!L',socket.inet_aton(plr.attributes['address']))[0])	#int ip BUG with port in ip address
			return str(struct.unpack('!L',socket.inet_aton(plr.attributes['address'][0:plr.attributes['address'].find(':')]))[0])

	def preloadPlrData(self):
		global plrdata
		q = sql_c.cursor()
		# may be im loaded data here
		#

	def getModelNum(self, userid):
		player  = playerlib.getPlayer(userid)
		mdl = player.attributes['model']
		cst.log(es.getplayername(userid) + ' ' + mdl)
		if mdl=='models/player/t_phoenix.mdl':
			n = 1
		elif mdl=='models/player/t_leet.mdl':
			n = 2
		elif mdl=='models/player/t_arctic.mdl':
			n = 3
		elif mdl=='models/player/t_guerilla.mdl':
			n = 4
		elif mdl=='models/player/ct_urban.mdl':
			n = 1
		elif mdl=='models/player/ct_gsg9.mdl':
			n = 2
		elif mdl=='models/player/ct_sas.mdl':
			n = 3
		elif mdl=='models/player/ct_gign.mdl':
			n = 4
		else:
			n = 1
		return n

	def setModelNum(self, userid, team, mdl):
		player  = playerlib.getPlayer(userid)
		if team=='2':
			if mdl == 1:
				player.set('model','models/player/t_phoenix.mdl')
			elif mdl == 2:
				player.set('model','models/player/t_leet.mdl')
			elif mdl == 3:
				player.set('model','models/player/t_arctic.mdl')
			elif mdl == 4:
				player.set('model','models/player/t_guerilla.mdl')
			else:
				player.set('model','models/player/t_phoenix.mdl')
		if team=='3':
			if mdl == 1:
				player.set('model','models/player/ct_urban.mdl')
			elif mdl == 2:
				player.set('model','models/player/ct_gsg9.mdl')
			elif mdl == 3:
				player.set('model','models/player/ct_sas.mdl')
			elif mdl == 4:
				player.set('model','models/player/ct_gign.mdl')
			else:
				player.set('model','models/player/ct_urban.mdl')
		return 1

	def changeteam(self, userid, teamid):
		es.server.queuecmd('est_DropWeapon %s weapon_c4'%userid)
		es.server.queuecmd('est_team %s %s' % (userid,teamid))
		plr = playerlib.getPlayer(userid)
		if plr.attributes['isdead']==0:
			es.server.queuecmd('est_spawn %s 1'%userid)

cst = cst()

class botProfile(object):
	botTemplates = {}
	botDefaults = {   'Skill': 0, 'Aggression': 0, 'ReactionTime': 0, 'AttackDelay': 0, 'Teamwork': 0, 'WeaponPreference': {} \
					, 'Cost': 0, 'Difficulty': 'NORMAL', 'VoicePitch': 0, 'Skin': 0}
	botProfile = {}
	def init(self):
		gamedir = es.getAddonPath(info.basename).replace('addons\eventscripts/'+info.basename,'')
		if os.path.isfile(gamedir+'botprofile.db'):
			a = open(gamedir + 'botprofile.db', 'r')
			b = a.readlines()
			a.close
			mode=''
			maskval = re.compile('^(.+) = (.+)$')
			maskTemp =re.compile('Template (.+)$')
			tempName = ''
			botName = ''
			for a in b:
				a = a.replace(chr(10),'');	a = a.replace(chr(13),'');a = a.replace(chr(9),' '); a = a.rstrip()
				if a.find('//')<>-1:
					a = a[0:a.find('//')]
				if a<>'':
					if a.startswith('End'):
						mode=''
						tempName = ''
						botName = ''
					if mode<>'':
						if mode=='Default':
							if re.match(maskval,a.strip()):
								c = re.findall(maskval,a.strip())
								if c[0][0]<>'WeaponPreference':
									self.botDefaults[c[0][0]] = c[0][1]
						if mode=='Template':
							if re.match(maskval,a.strip()):
								c = re.findall(maskval,a.strip())
								if c[0][0]=='WeaponPreference':
									self.botTemplates[tempName]['WeaponPreference'][len(self.botTemplates[tempName]['WeaponPreference'])] = c[0][1]
								else:
									self.botTemplates[tempName][c[0][0]]=c[0][1]
						if mode=='Bot':
							c = re.findall(maskval,a.strip())
							if c[0][0]=='WeaponPreference':
								self.botPrifle[botName]['WeaponPreference'][len(self.botProfile[botName]['WeaponPreference'])] = c[0][1]
							else:
								self.botProfile[botName][c[0][0]]=c[0][1]
					if mode=='':
						if a.startswith('Default'):
							mode='Default'
						elif a.startswith('Template'):
							mode='Template'
							if re.match(maskTemp,a.strip()):
								c = re.findall(maskTemp,a.strip())
								tempName = c[0]
								ar = self.botDefaults
								self.botTemplates[tempName]=self.botDefaults.copy()
								self.botTemplates[tempName]['WeaponPreference']=self.botDefaults['WeaponPreference'].copy()
						elif a=='End':
							mode=''
						elif a<>'':
							c = a.split()
							if len(c)>=2:
								t=c[0].split('+')
								if ((len(t)==1  and t[0] in self.botTemplates) or (len(t)==2  and t[0] in self.botTemplates and t[1] in self.botTemplates)):
									botName=c[1]
									mode='Bot'
									self.botProfile[c[1]] = self.botTemplates[t[0]].copy()
									if len(t)==2:
										self.botProfile[c[1]]['WeaponPreference'] = self.botTemplates[t[1]]['WeaponPreference'].copy()
	def getKpd(self,userid):
		# Approximately calculate nearest kdr bot of its skills
		if es.isbot(userid):
			botName = es.getplayername(userid).replace(str(es.ServerVar("bot_prefix")),'').strip()
			if botName in self.botProfile:
				if self.botProfile[botName]['Difficulty'].find('EXPERT')<>-1:
					kpc = 1.25
				elif self.botProfile[botName]['Difficulty'].find('HARD')<>-1:
					kpc = 1.15
				elif self.botProfile[botName]['Difficulty'].find('NORMAL')<>-1:
					kpc = 1.05
				else:
					kpc = 1
				react =  1.2 / float( 1 + float(self.botProfile[botName]['AttackDelay'])) * 1 /( 1 + float(self.botProfile[botName]['ReactionTime']))
				agil =  (float(self.botProfile[botName]['Skill']) * float(self.botProfile[botName]['Aggression'])/10000 + 0.1) * kpc * kpc
				kpd = round( react * agil,2)
				return kpd
			else:
				return ''
		else:
			return ''


bots = botProfile()
bots.init()
# ================================================================================== #

